#region Copyright Syncfusion Inc. 2001 - 2017
// Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using System.Data.SqlClient;

using System.IO;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;
using System.Collections.Specialized;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using System.Runtime.Serialization;
using DataGrid;
using Syncfusion.GridHelperClasses;
using System.Collections.ObjectModel;

namespace SortingMethods
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form2 : Form//GridDemoForm
    {
        #region  "API Definitions"

        private GridGroupingControl gridGroupingControl1;
        #endregion

        #region "Constructor"

        public Form2()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            #region "DataSource"
            DataTable dataTable = new DataTable();
            dataTable.Columns.Add("Name");
            dataTable.Columns.Add("Id");
            dataTable.Columns.Add("Amount", typeof(double));
            dataTable.Columns.Add("DateTime");//,typeof(DateTime));
            dataTable.Columns.Add("Button");
            Random random = new Random();
            for (int i = 0; i < 500; i++)
            {
                DataRow dataRow = dataTable.NewRow();
                dataRow[0] = "category"+i;
                dataRow[1] = "E" + random.Next(30);
                dataRow[2] = random.Next(random.Next(2000, 20100)) / 3.24;
                //To add the date as string
                dataRow[3] = DateTime.Now.AddMinutes(i).ToShortTimeString();
                dataRow[4] = "Desc" + i;
                dataTable.Rows.Add(dataRow);
            }
            //To set the datasource
            this.gridGroupingControl1.DataSource = dataTable;
            #endregion

            this.gridGroupingControl1.ShowGroupDropArea = false;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;

            //To set the format for the time
            //this.gridGroupingControl1.TableDescriptor.Columns["DateTime"].Appearance.AnyRecordFieldCell.Format = "HH:MM";

            //To hidde the drop down button
            this.gridGroupingControl1.TableDescriptor.Columns["DateTime"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            //To Show the default value on AddNewrRecord row
            this.gridGroupingControl1.ShowDefaultValuesInAddNewRecord = true;
            this.gridGroupingControl1.TableDescriptor.Fields["DateTime"].DefaultValue = DateTime.Now.ToShortTimeString();
            //Event Subscription
            //this.gridGroupingControl1.QueryCellStyleInfo += GridGroupingControl1_QueryCellStyleInfo;
            this.gridGroupingControl1.CurrentRecordContextChange += GridGroupingControl1_CurrentRecordContextChange;
           // this.gridGroupingControl1.TableControlCurrentCellMoved += GridGroupingControl1_TableControlCurrentCellMoved;
        }
        //Using TableControlCurrentCellMoved event
        private void GridGroupingControl1_TableControlCurrentCellMoved(object sender, GridTableControlCurrentCellMovedEventArgs e)
        {
            if (e.TableControl.Table.CurrentRecord != null && e.TableControl.Table.CurrentRecord.Kind == DisplayElementKind.AddNewRecord)
            {
                //To set the default value
                this.gridGroupingControl1.TableDescriptor.Fields["DateTime"].DefaultValue = DateTime.Now.ToShortTimeString();

            }
        }
        //Using CurrentRecordContextChange event
        private void GridGroupingControl1_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
        {
            if(e.Table.CurrentRecord != null && e.Table.CurrentRecord.Kind == DisplayElementKind.AddNewRecord)
            {
                //To set the default value
                this.gridGroupingControl1.TableDescriptor.Fields["DateTime"].DefaultValue = DateTime.Now.ToShortTimeString();
            }
        }

        //Event Customization
        private void GridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            if(e.TableCellIdentity.RowIndex > 0 && e.TableCellIdentity.Column !=null && e.TableCellIdentity.Column.Name == "DateTime" && e.Style.CellType != "ColumnHeaderCell")
            {
                //To set the format for the time
                e.Style.Format = "HH:MM";
            }
        }

        #endregion

        #region "Designer Stuffs"
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.AlphaBlendSelectionColor = System.Drawing.Color.FromArgb(((int)(((byte)(64)))), ((int)(((byte)(0)))), ((int)(((byte)(120)))), ((int)(((byte)(215)))));
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridGroupingControl1.Location = new System.Drawing.Point(0, 0);
            this.gridGroupingControl1.Margin = new System.Windows.Forms.Padding(4);
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
            this.gridGroupingControl1.Size = new System.Drawing.Size(853, 480);
            this.gridGroupingControl1.TabIndex = 0;
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            this.gridGroupingControl1.UseRightToLeftCompatibleTextBox = true;
            this.gridGroupingControl1.VersionInfo = "12.4400.0.24";
            // 
            // Form2
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(8F, 16F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(853, 480);
            this.Controls.Add(this.gridGroupingControl1);
            this.Margin = new System.Windows.Forms.Padding(4);
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "Form2";
            this.Text = "Printing";
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
            this.ResumeLayout(false);

        }


        #endregion

        #endregion

    }
}
